--- a/vk.xml	2023-10-03 19:55:11.399975517 -0700
+++ b/vk.xml	2023-10-03 19:55:26.074975427 -0700
@@ -484 +484,2 @@
-        <type requires="VkShaderCreateFlagBitsEXT"        category="bitmask">typedef <type>VkFlags</type> <name>VkShaderCreateFlagsEXT</name>;</type>
+        <type requires="VkShaderCreateFlagBitsEXT"   category="bitmask">typedef <type>VkFlags</type> <name>VkShaderCreateFlagsEXT</name>;</type>
+        <type requires="VkPresentStageFlagBitsEXT"   category="bitmask">typedef <type>VkFlags</type> <name>VkPresentStageFlagsEXT</name>;</type>
@@ -867,0 +869 @@
+        <type name="VkPresentStageFlagBitsEXT" category="enum"/>
@@ -3169,0 +3172,70 @@
+        <type category="struct" name="VkPhysicalDevicePresentTimingFeaturesEXT" structextends="VkPhysicalDeviceFeatures2,VkDeviceCreateInfo">
+            <member values="VK_STRUCTURE_TYPE_PHYSICAL_DEVICE_PRESENT_TIMING_FEATURES_EXT"><type>VkStructureType</type> <name>sType</name></member>
+            <member optional="true"><type>void</type>*            <name>pNext</name></member>
+            <member><type>VkBool32</type>                         <name>presentTiming</name><comment>vkGetPastPresentationTimingEXT is supported</comment></member>
+            <member><type>VkBool32</type>                         <name>presentAtAbsoluteTime</name><comment>Absolute time can be used to specify present time</comment></member>
+            <member><type>VkBool32</type>                         <name>presentAtRelativeTime</name><comment>Relative time can be used to specify present duration</comment></member>
+        </type>
+        <type category="struct" name="VkPresentTimingSurfaceCapabilitiesEXT" structextends="VkSurfaceCapabilities2KHR">
+            <member values="VK_STRUCTURE_TYPE_PRESENT_TIMING_SURFACE_CAPABILITIES_EXT"><type>VkStructureType</type> <name>sType</name></member>
+            <member optional="true"><type>void</type>*            <name>pNext</name></member>
+            <member><type>VkBool32</type>                         <name>presentTimingSupported</name><comment>presentation timings of the surface can be queried using vkGetPastPresentationTimingEXT</comment></member>
+            <member><type>VkBool32</type>                         <name>presentAtAbsoluteTimeSupported</name><comment>surface can be presented using absolute times</comment></member>
+            <member><type>VkBool32</type>                         <name>presentAtRelativeTimeSupported</name><comment>surface can be presented using relative times</comment></member>
+            <member><type>VkPresentStageFlagsEXT</type>           <name>presentStageQueries</name><comment>present stages that can be queried</comment></member>
+            <member><type>VkPresentStageFlagsEXT</type>           <name>presentStageTargets</name><comment>present stages that can be used as a present target</comment></member>
+        </type>
+        <type category="struct" name="VkSwapchainPresentTimingCreateInfoEXT" structextends="VkSwapchainCreateInfoKHR">
+            <member values="VK_STRUCTURE_TYPE_SWAPCHAIN_PRESENT_TIMING_CREATE_INFO_EXT"><type>VkStructureType</type> <name>sType</name></member>
+            <member optional="true">const <type>void</type>*      <name>pNext</name></member>
+            <member><type>uint32_t</type>                         <name>presentTimingQueueSize</name></member>
+            <member><type>VkPresentStageFlagsEXT</type>           <name>presentStageQueries</name><comment>present stages to provide feedback for</comment></member>
+            <member><type>VkPresentStageFlagsEXT</type>           <name>presentStageTarget</name><comment>present stage used to interpret the target present time</comment></member>
+            <member><type>VkBool32</type>                         <name>presentAtRelativeTime</name><comment>if using target present times, interpret them as relative times</comment></member>
+        </type>
+        <type category="struct" name="VkSwapchainTimingPropertiesEXT">
+            <member values="VK_STRUCTURE_TYPE_SWAPCHAIN_TIMING_PROPERTIES_EXT"><type>VkStructureType</type> <name>sType</name></member>
+            <member optional="true">const <type>void</type>*      <name>pNext</name></member>
+            <member><type>uint64_t</type>                         <name>refreshDuration</name><comment>Number of nanoseconds from the start of one refresh cycle to the next</comment></member>
+            <member><type>VkBool32</type>                         <name>variableRefresh</name></member>
+        </type>
+        <type category="struct" name="VkSwapchainTimeDomainPropertiesEXT">
+            <member values="VK_STRUCTURE_TYPE_SWAPCHAIN_TIME_DOMAIN_PROPERTIES_EXT"><type>VkStructureType</type> <name>sType</name></member>
+            <member optional="true"><type>void</type>*            <name>pNext</name></member>
+            <member><type>VkTimeDomainEXT</type>                  <name>timeDomain</name><comment>Available time domain to use with the swapchain</comment></member>
+        </type>
+        <type category="struct" name="VkSwapchainTimingInfoEXT">
+            <member values="VK_STRUCTURE_TYPE_SWAPCHAIN_TIMING_INFO_EXT"><type>VkStructureType</type> <name>sType</name></member>
+            <member optional="true">const <type>void</type>*      <name>pNext</name></member>
+            <member><type>VkTimeDomainEXT</type>                  <name>timeDomain</name><comment>Time domain selected by the application to be used for the swapchain time values</comment></member>
+        </type>
+        <type category="struct" name="VkPresentStageTimeEXT">
+            <member><type>VkPresentStageFlagsEXT</type>           <name>stage</name></member>
+            <member><type>uint64_t</type>                         <name>time</name><comment>Time in nanoseconds of the associated stage</comment></member>
+        </type>
+        <type category="struct" name="VkPastPresentationTimingEXT">
+            <member values="VK_STRUCTURE_TYPE_PAST_PRESENTATION_TIMING_EXT"><type>VkStructureType</type> <name>sType</name></member>
+	    <member optional="true">const <type>void</type>*      <name>pNext</name></member>
+            <member><type>uint64_t</type>                         <name>presentId</name><comment>Application-provided identifier, previously given to vkQueuePresentKHR</comment></member>
+            <member><type>uint64_t</type>                         <name>targetPresentTime</name><comment>Earliest time an image should have been presented, previously given to vkQueuePresentKHR</comment></member>
+            <member><type>uint32_t</type>                         <name>presentStageCount</name><comment>TBD</comment></member>
+            <member><type>VkPresentStageTimeEXT</type>*           <name>pPresentStages</name><comment>TBD</comment></member>
+            <member><type>VkBool32</type>                         <name>timingPropertiesChanged</name><comment>VK_TRUE if swapchain's timing properties changed since last queried</comment></member>
+            <member><type>VkBool32</type>                         <name>timeDomainChanged</name><comment>VK_TRUE if the swapchain no longer supports the enabled time domain</comment></member>
+            <member><type>VkBool32</type>                         <name>reportComplete</name><comment>VK_TRUE if all the present stages have been reported.</comment></member>
+        </type>
+        <type category="struct" name="VkPresentTimesInfoEXT" structextends="VkPresentInfoKHR">
+            <member values="VK_STRUCTURE_TYPE_PRESENT_TIMES_INFO_EXT"><type>VkStructureType</type> <name>sType</name></member>
+            <member optional="true">const <type>void</type>*      <name>pNext</name></member>
+            <member><type>uint32_t</type>                         <name>swapchainCount</name><comment>Copy of VkPresentInfoKHR::swapchainCount</comment></member>
+            <member len="swapchainCount" optional="true">const <type>VkPresentTimeEXT</type>*   <name>pTimes</name><comment>When to present images</comment></member>
+        </type>
+        <type category="union" name="VkPresentTimeEXT" comment="// Union allowing specification of either absolute or relative present time. Actual value selected is based on swapchain info.">
+            <member><type>uint64_t</type>         <name>targetPresentTime</name></member>
+            <member><type>uint64_t</type>         <name>minPresentDuration</name></member>
+        </type>
+        <type category="struct" name="VkSwapchainCalibratedTimestampInfoEXT" structextends="VkCalibratedTimestampInfoEXT">
+            <member values="VK_STRUCTURE_TYPE_SWAPCHAIN_CALIBRATED_TIMESTAMP_INFO_EXT"><type>VkStructureType</type> <name>sType</name></member>
+            <member optional="true">const <type>void</type>*      <name>pNext</name></member>
+            <member externsync="true"><type>VkSwapchainKHR</type> <name>swapchain</name></member>
+        </type>
@@ -10331,0 +10404,7 @@
+    <enums name="VkPresentStageFlagBitsEXT" type="bitmask">
+        <enum bitpos="0"    name="VK_PRESENT_STAGE_IMAGE_HANDOFF_BIT_EXT"/>
+        <enum bitpos="1"    name="VK_PRESENT_STAGE_IMAGE_LATCHED_BIT_EXT"/>
+        <enum bitpos="2"    name="VK_PRESENT_STAGE_IMAGE_FIRST_PIXEL_OUT_BIT_EXT"/>
+        <enum bitpos="3"    name="VK_PRESENT_STAGE_IMAGE_FIRST_PIXEL_VISIBLE_BIT_EXT"/>
+    </enums>
+
@@ -11992 +12071 @@
-        <command successcodes="VK_SUCCESS,VK_SUBOPTIMAL_KHR" errorcodes="VK_ERROR_OUT_OF_HOST_MEMORY,VK_ERROR_OUT_OF_DEVICE_MEMORY,VK_ERROR_DEVICE_LOST,VK_ERROR_OUT_OF_DATE_KHR,VK_ERROR_SURFACE_LOST_KHR,VK_ERROR_FULL_SCREEN_EXCLUSIVE_MODE_LOST_EXT">
+        <command successcodes="VK_SUCCESS,VK_SUBOPTIMAL_KHR" errorcodes="VK_ERROR_OUT_OF_HOST_MEMORY,VK_ERROR_OUT_OF_DEVICE_MEMORY,VK_ERROR_DEVICE_LOST,VK_ERROR_OUT_OF_DATE_KHR,VK_ERROR_SURFACE_LOST_KHR,VK_ERROR_FULL_SCREEN_EXCLUSIVE_MODE_LOST_EXT,VK_ERROR_PRESENT_TIMING_QUEUE_FULL_EXT">
@@ -11996,0 +12076,6 @@
+        <command successcodes="VK_SUCCESS" errorcodes="VK_ERROR_OUT_OF_HOST_MEMORY,VK_ERROR_OUT_OF_DEVICE_MEMORY,VK_ERROR_SURFACE_LOST_KHR">
+            <proto><type>VkResult</type> <name>vkSetSwapchainTimingEXT</name></proto>
+            <param><type>VkDevice</type> <name>device</name></param>
+            <param externsync="true"><type>VkSwapchainKHR</type> <name>swapchain</name></param>
+            <param optional="true">const <type>VkSwapchainTimingInfoEXT</type>* <name>pSwapchainTimingInfo</name></param>
+        </command>
@@ -12618,0 +12704,7 @@
+        <command successcodes="VK_SUCCESS,VK_INCOMPLETE" errorcodes="VK_ERROR_DEVICE_LOST,VK_ERROR_OUT_OF_DATE_KHR,VK_ERROR_SURFACE_LOST_KHR">
+            <proto><type>VkResult</type> <name>vkGetPastPresentationTimingEXT</name></proto>
+            <param><type>VkDevice</type> <name>device</name></param>
+            <param externsync="true"><type>VkSwapchainKHR</type> <name>swapchain</name></param>
+            <param optional="false,true"><type>uint32_t</type>* <name>pPresentationTimingCount</name></param>
+            <param optional="true" len="pPresentationTimingCount"><type>VkPastPresentationTimingEXT</type>* <name>pPresentationTimings</name></param>
+        </command>
@@ -14727,0 +14820,13 @@
+        <command successcodes="VK_SUCCESS" errorcodes="VK_ERROR_OUT_OF_HOST_MEMORY,VK_ERROR_OUT_OF_DEVICE_MEMORY,VK_ERROR_SURFACE_LOST_KHR">
+            <proto><type>VkResult</type> <name>vkGetSwapchainTimingPropertiesEXT</name></proto>
+            <param><type>VkDevice</type> <name>device</name></param>
+            <param externsync="true"><type>VkSwapchainKHR</type> <name>swapchain</name></param>
+            <param><type>VkSwapchainTimingPropertiesEXT</type>* <name>pSwapchainTimingProperties</name></param>
+        </command>
+        <command successcodes="VK_SUCCESS,VK_INCOMPLETE" errorcodes="VK_ERROR_OUT_OF_HOST_MEMORY,VK_ERROR_OUT_OF_DEVICE_MEMORY,VK_ERROR_SURFACE_LOST_KHR">
+            <proto><type>VkResult</type> <name>vkGetSwapchainTimeDomainsEXT</name></proto>
+            <param><type>VkDevice</type> <name>device</name></param>
+            <param externsync="true"><type>VkSwapchainKHR</type> <name>swapchain</name></param>
+            <param optional="false,true"><type>uint32_t</type>* <name>pSwapchainTimeDomainCount</name></param>
+            <param optional="true" len="pSwapchainTimeDomainCount"><type>VkSwapchainTimeDomainPropertiesEXT</type>* <name>pSwapchainTimeDomains</name></param>
+        </command>
@@ -19312 +19417 @@
-        <extension name="VK_KHR_extension_209" number="209" type="device" author="KHR" contact="Ian Elliott @ianelliott" supported="disabled">
+        <extension name="VK_EXT_present_timing" number="209" type="device" depends="VK_KHR_swapchain+VK_KHR_present_id+VK_KHR_get_surface_capabilities2" author="EXT" contact="Ian Elliott @ianelliott" supported="vulkan">
@@ -19314,2 +19419,30 @@
-                <enum value="0"                                         name="VK_KHR_EXTENSION_209_SPEC_VERSION"/>
-                <enum value="&quot;VK_KHR_extension_209&quot;"          name="VK_KHR_EXTENSION_209_EXTENSION_NAME"/>
+                <enum value="4"                                         name="VK_EXT_PRESENT_TIMING_SPEC_VERSION"/>
+                <enum value="&quot;VK_EXT_present_timing&quot;"         name="VK_EXT_PRESENT_TIMING_EXTENSION_NAME"/>
+                <enum offset="0" extends="VkStructureType"              name="VK_STRUCTURE_TYPE_SWAPCHAIN_TIMING_PROPERTIES_EXT"/>
+                <enum offset="1" extends="VkStructureType"              name="VK_STRUCTURE_TYPE_SWAPCHAIN_TIME_DOMAIN_PROPERTIES_EXT"/>
+                <enum offset="2" extends="VkStructureType"              name="VK_STRUCTURE_TYPE_SWAPCHAIN_PRESENT_TIMING_CREATE_INFO_EXT"/>
+                <enum offset="3" extends="VkStructureType"              name="VK_STRUCTURE_TYPE_SWAPCHAIN_TIMING_INFO_EXT"/>
+                <enum offset="4" extends="VkStructureType"              name="VK_STRUCTURE_TYPE_PRESENT_TIMES_INFO_EXT"/>
+                <enum offset="5" extends="VkStructureType"              name="VK_STRUCTURE_TYPE_PAST_PRESENTATION_TIMING_EXT"/>
+                <enum offset="6" extends="VkStructureType"              name="VK_STRUCTURE_TYPE_PHYSICAL_DEVICE_PRESENT_TIMING_FEATURES_EXT"/>
+                <enum offset="7" extends="VkStructureType"              name="VK_STRUCTURE_TYPE_PRESENT_TIMING_SURFACE_CAPABILITIES_EXT"/>
+                <enum offset="8" extends="VkStructureType"              name="VK_STRUCTURE_TYPE_SWAPCHAIN_CALIBRATED_TIMESTAMP_INFO_EXT"/>
+                <enum offset="0" extends="VkTimeDomainEXT"              name="VK_TIME_DOMAIN_SWAPCHAIN_LOCAL_EXT"/>
+                <enum offset="0" extends="VkResult" dir="-"             name="VK_ERROR_PRESENT_TIMING_QUEUE_FULL_EXT"/>
+                <type name="VkPhysicalDevicePresentTimingFeaturesEXT"/>
+                <type name="VkPresentTimingSurfaceCapabilitiesEXT"/>
+                <type name="VkSwapchainCalibratedTimestampInfoEXT"/>
+                <type name="VkSwapchainPresentTimingCreateInfoEXT"/>
+                <type name="VkSwapchainTimingPropertiesEXT"/>
+                <type name="VkSwapchainTimeDomainPropertiesEXT"/>
+                <type name="VkSwapchainTimingInfoEXT"/>
+                <type name="VkPastPresentationTimingEXT"/>
+                <type name="VkPresentTimesInfoEXT"/>
+                <type name="VkPresentTimeEXT"/>
+                <type name="VkPresentStageTimeEXT"/>
+                <type name="VkPresentStageFlagBitsEXT"/>
+                <type name="VkPresentStageFlagsEXT"/>
+                <command name="vkGetSwapchainTimingPropertiesEXT"/>
+                <command name="vkGetSwapchainTimeDomainsEXT"/>
+                <command name="vkGetPastPresentationTimingEXT"/>
+                <command name="vkSetSwapchainTimingEXT"/>
